import GraphFunctions
import os

if not os.path.exists('part1results'):
    os.makedirs('part1results')
    
data_set = 'facebook'
links_file = 'data/' + data_set + '_links'

first_method = 'mod'
second_method = 'mod'

overlap_threshold = 1
presence_threshold = 1
first_part_file = 'part1results/part1_' + data_set + '_' + first_method
membership_file = 'part1results/membership_' + data_set + '_' + first_method
sim_file = 'part1results/simfile_' + data_set + '_' + first_method
sim_threshold_min = 0.2
###part 1
edges = GraphFunctions.GetEdgesIntoDict(links_file) #read the edgefile
max = 0
for x in edges:
    if len(edges[x]) > max:
        max = len(edges[x])


GraphFunctions.FirstPartition(edges, first_part_file, first_method, data_set) #get the small communities and write them to a file
for min_comm_size in [2]:
    GraphFunctions.GetMembership(first_part_file, membership_file, min_comm_size) 
    total_lines = GraphFunctions.GetCommSimilarities(first_part_file, membership_file, sim_file, sim_threshold_min, min_comm_size) #calculate similarity between each pair of small communities; minimum threshold is set to jaccard of 0.2
    total_lines = 1
    
    #part 2
    
    max_den = 0
    sim = 0
    
    max_sim = 0
    max_den = 0
    second_method = 'mod'
    out_file = data_set + '_results_' + first_method + '_' + second_method + '_out'
    return_vals = GraphFunctions.SecondPartition(edges, 0, overlap_threshold, presence_threshold, sim_file, first_part_file, out_file, total_lines, min_comm_size, second_method)
    GraphFunctions.CleanComms(out_file)
    os.remove(out_file)